﻿Imports System.Runtime.InteropServices

Public Class CapturePicker
    Implements IDisposable

#Region "API"
    <DllImport("Combase.dll", EntryPoint:="WindowsCreateString")>
    <PreserveSig> Private Shared Function WindowsCreateString(<[In], MarshalAs(UnmanagedType.LPWStr)> sourceString As String,
                                                              <[In]> length As Integer,
                                                              <Out> ByRef hString As IntPtr) As Integer
    End Function

    <DllImport("Combase.dll", EntryPoint:="WindowsGetStringRawBuffer")>
    <PreserveSig> Private Shared Function WindowsGetStringRawBuffer(<[In]> hString As IntPtr,
                                                                    <Out> ByRef length As Integer) As IntPtr
    End Function

    <DllImport("Combase.dll", EntryPoint:="WindowsDeleteString")>
    <PreserveSig> Private Shared Function WindowsDeleteString(<[In]> hString As IntPtr) As Integer
    End Function

    <DllImport("Combase.dll", EntryPoint:="RoGetActivationFactory")>
    <PreserveSig> Private Shared Function RoGetActivationFactory(<[In]> activatableClassId As IntPtr,
                                                                 <[In], MarshalAs(UnmanagedType.LPStruct)> riid As Guid,
                                                                 <Out> ByRef factory As IntPtr) As Integer
    End Function

    <DllImport("Combase.dll", EntryPoint:="RoActivateInstance")>
    <PreserveSig> Private Shared Function RoActivateInstance(<[In]> activatableClassId As IntPtr,
                                                             <Out> ByRef instance As IntPtr) As Integer
    End Function

    <DllImport("User32.dll", EntryPoint:="FindWindowW")>
    <PreserveSig> Private Shared Function FindWindow(<[In]> lpClassName As IntPtr,
                                                     <[In]> lpWindowName As IntPtr) As IntPtr
    End Function

    <DllImport("User32.dll", EntryPoint:="GetWindowLongW")>
    <PreserveSig> Private Shared Function GetWindowLong(<[In]> hwnd As IntPtr,
                                                        <[In]> nIndex As Integer) As Integer
    End Function

    <DllImport("D3D11.dll", EntryPoint:="D3D11CreateDevice")>
    <PreserveSig> Private Shared Function D3D11CreateDevice(<[In]> pAdapter As IntPtr,
                                                            <[In]> DriverType As D3D_DRIVER_TYPE,
                                                            <[In]> Software As IntPtr,
                                                            <[In]> flags As D3D11_CREATE_DEVICE_FLAG,
                                                            <[In]> pfeatureLevels As Integer,
                                                            <[In]> featureLevels As Integer,
                                                            <[In]> SDKVersion As Integer,
                                                            <Out> ByRef ppDevice As IntPtr,
                                                            <Out> ByRef pFeatureLevel As Integer,
                                                            <Out> ByRef ppImmediateContext As IntPtr) As Integer
    End Function

    <DllImport("D3D11.dll", EntryPoint:="CreateDirect3D11DeviceFromDXGIDevice")>
    <PreserveSig> Private Shared Function CreateDirect3D11DeviceFromDXGIDevice(<[In]> dxgiDevice As IntPtr,
                                                                               <Out> ByRef graphicsDevice As IntPtr) As Integer
    End Function
#End Region

#Region "Enum"
    Private Enum VTable_Interfaces As Integer
        ' IClosable
        IClosable_Close = 6

        ' IAsyncInfo
        IAsyncInfo_GetStatus = 7
        IAsyncInfo_Close = 10

        ' IAsyncInterface
        IAsyncInterface_GetResults = 8

        ' IGraphicsCaptureSessionStatics
        IGraphicsCaptureSessionStatics_IsSupported = 6

        ' IInitializeWithWindow
        IInitializeWithWindow_Initialize = 3

        ' IGraphicsCapturePicker
        IGraphicsCapturePicker_PickSingleItemAsync = 6

        ' IGraphicsCaptureItem
        IGraphicsCaptureItem_GetDisplayName = 6
        IGraphicsCaptureItem_GetSize = 7

        ' IDirect3D11CaptureFramePoolStatics
        IDirect3D11CaptureFramePoolStatics_Create = 6

        ' IDirect3D11CaptureFramePool
        IDirect3D11CaptureFramePool_TryGetNextFrame = 7
        IDirect3D11CaptureFramePool_CreateCaptureSession = 10

        ' IGraphicsCaptureSession
        IGraphicsCaptureSession_StartCapture = 6

        ' IGraphicsCaptureSession2
        IGraphicsCaptureSession2_GetIsCursorCaptureEnabled = 6
        IGraphicsCaptureSession2_PutIsCursorCaptureEnabled = 7

        ' IDirect3D11CaptureFrame
        IDirect3D11CaptureFrame_GetSurface = 6

        ' IDirect3DDxgiInterfaceAccess
        IDirect3DDxgiInterfaceAccess_GetInterface = 3

        ' ID3D11Texture2D
        ID3D11Texture2D_GetDesc = 10

        ' ID3D11Device
        ID3D11Device_CreateTexture2D = 5

        ' ID3D11DeviceContext
        ID3D11DeviceContext_Map = 14
        ID3D11DeviceContext_CopyResource = 47

    End Enum

    Private Enum AsyncStatus As Integer
        Started = 0
        Completed = 1
        Canceled = 2
        [Error] = 3
    End Enum

    Private Enum D3D_DRIVER_TYPE As Integer
        D3D_DRIVER_TYPE_UNKNOWN = 0
        D3D_DRIVER_TYPE_HARDWARE = 1
        D3D_DRIVER_TYPE_REFERENCE = 2
        D3D_DRIVER_TYPE_NULL = 3
        D3D_DRIVER_TYPE_SOFTWARE = 4
        D3D_DRIVER_TYPE_WARP = 5
    End Enum

    Private Enum D3D11_CREATE_DEVICE_FLAG As Integer
        D3D11_CREATE_DEVICE_SINGLETHREADED = &H1
        D3D11_CREATE_DEVICE_DEBUG = &H2
        D3D11_CREATE_DEVICE_SWITCH_TO_REF = &H4
        D3D11_CREATE_DEVICE_PREVENT_INTERNAL_THREADING_OPTIMIZATIONS = &H8
        D3D11_CREATE_DEVICE_BGRA_SUPPORT = &H20
        D3D11_CREATE_DEVICE_DEBUGGABLE = &H40
        D3D11_CREATE_DEVICE_PREVENT_ALTERING_LAYER_SETTINGS_FROM_REGISTRY = &H80
        D3D11_CREATE_DEVICE_DISABLE_GPU_TIMEOUT = &H100
        D3D11_CREATE_DEVICE_VIDEO_SUPPORT = &H800
    End Enum

    Private Enum D3D11_USAGE
        D3D11_USAGE_DEFAULT = 0
        D3D11_USAGE_IMMUTABLE = 1
        D3D11_USAGE_DYNAMIC = 2
        D3D11_USAGE_STAGING = 3
    End Enum

    Private Enum D3D11_CPU_ACCESS_FLAG As Integer
        D3D11_CPU_ACCESS_WRITE = &H10000
        D3D11_CPU_ACCESS_READ = &H20000
    End Enum

    Private Enum D3D11_BIND_FLAG As Integer
        D3D11_BIND_DEFAULT = &H0&
        D3D11_BIND_VERTEX_BUFFER = &H1&
        D3D11_BIND_INDEX_BUFFER = &H2&
        D3D11_BIND_CONSTANT_BUFFER = &H4&
        D3D11_BIND_SHADER_RESOURCE = &H8&
        D3D11_BIND_STREAM_OUTPUT = &H10&
        D3D11_BIND_RENDER_TARGET = &H20&
        D3D11_BIND_DEPTH_STENCIL = &H40&
        D3D11_BIND_UNORDERED_ACCESS = &H80&
        D3D11_BIND_DECODER = &H200&
        D3D11_BIND_VIDEO_ENCODER = &H400&
    End Enum

    Private Enum D3D11_RESOURCE_MISC_FLAG As Integer
        D3D11_RESOURCE_MISC_DEFAULT = &H0&
        D3D11_RESOURCE_MISC_GENERATE_MIPS = &H1&
        D3D11_RESOURCE_MISC_SHARED = &H2&
        D3D11_RESOURCE_MISC_TEXTURECUBE = &H4&
        D3D11_RESOURCE_MISC_DRAWINDIRECT_ARGS = &H1&
        D3D11_RESOURCE_MISC_BUFFER_ALLOW_RAW_VIEWS = &H2&
        D3D11_RESOURCE_MISC_BUFFER_STRUCTURED = &H4&
        D3D11_RESOURCE_MISC_RESOURCE_CLAMP = &H8&
        D3D11_RESOURCE_MISC_SHARED_KEYEDMUTEX = &H10&
        D3D11_RESOURCE_MISC_GDI_COMPATIBLE = &H20&
        D3D11_RESOURCE_MISC_SHARED_NTHANDLE = &H80&
        D3D11_RESOURCE_MISC_RESTRICTED_CONTENT = &H100&
        D3D11_RESOURCE_MISC_RESTRICT_SHARED_RESOURCE = &H200&
        D3D11_RESOURCE_MISC_RESTRICT_SHARED_RESOURCE_DRIVER = &H400&
        D3D11_RESOURCE_MISC_GUARDED = &H800&
        D3D11_RESOURCE_MISC_TILE_POOL = &H2000&
        D3D11_RESOURCE_MISC_TILED = &H4000&
        D3D11_RESOURCE_MISC_HW_PROTECTED = &H8000&
    End Enum

    Private Enum D3D11_MAP As Integer
        D3D11_MAP_READ = 1
        D3D11_MAP_WRITE = 2
        D3D11_MAP_READ_WRITE = 3
        D3D11_MAP_WRITE_DISCARD = 4
        D3D11_MAP_WRITE_NO_OVERWRITE = 5
    End Enum

    Private Enum DirectXPixelFormat As Integer  'DXGI_FORMAT
        Unknown = 0
        R32G32B32A32Typeless = 1
        R32G32B32A32Float = 2
        R32G32B32A32UInt = 3
        R32G32B32A32Int = 4
        R32G32B32Typeless = 5
        R32G32B32Float = 6
        R32G32B32UInt = 7
        R32G32B32Int = 8
        R16G16B16A16Typeless = 9
        R16G16B16A16Float = 10
        R16G16B16A16UIntNormalized = 11
        R16G16B16A16UInt = 12
        R16G16B16A16IntNormalized = 13
        R16G16B16A16Int = 14
        R32G32Typeless = 15
        R32G32Float = 16
        R32G32UInt = 17
        R32G32Int = 18
        R32G8X24Typeless = 19
        D32FloatS8X24UInt = 20
        R32FloatX8X24Typeless = 21
        X32TypelessG8X24UInt = 22
        R10G10B10A2Typeless = 23
        R10G10B10A2UIntNormalized = 24
        R10G10B10A2UInt = 25
        R11G11B10Float = 26
        R8G8B8A8Typeless = 27
        R8G8B8A8UIntNormalized = 28
        R8G8B8A8UIntNormalizedSrgb = 29
        R8G8B8A8UInt = 30
        R8G8B8A8IntNormalized = 31
        R8G8B8A8Int = 32
        R16G16Typeless = 33
        R16G16Float = 34
        R16G16UIntNormalized = 35
        R16G16UInt = 36
        R16G16IntNormalized = 37
        R16G16Int = 38
        R32Typeless = 39
        D32Float = 40
        R32Float = 41
        R32UInt = 42
        R32Int = 43
        R24G8Typeless = 44
        D24UIntNormalizedS8UInt = 45
        R24UIntNormalizedX8Typeless = 46
        X24TypelessG8UInt = 47
        R8G8Typeless = 48
        R8G8UIntNormalized = 49
        R8G8UInt = 50
        R8G8IntNormalized = 51
        R8G8Int = 52
        R16Typeless = 53
        R16Float = 54
        D16UIntNormalized = 55
        R16UIntNormalized = 56
        R16UInt = 57
        R16IntNormalized = 58
        R16Int = 59
        R8Typeless = 60
        R8UIntNormalized = 61
        R8UInt = 62
        R8IntNormalized = 63
        R8Int = 64
        A8UIntNormalized = 65
        R1UIntNormalized = 66
        R9G9B9E5SharedExponent = 67
        R8G8B8G8UIntNormalized = 68
        G8R8G8B8UIntNormalized = 69
        BC1Typeless = 70
        BC1UIntNormalized = 71
        BC1UIntNormalizedSrgb = 72
        BC2Typeless = 73
        BC2UIntNormalized = 74
        BC2UIntNormalizedSrgb = 75
        BC3Typeless = 76
        BC3UIntNormalized = 77
        BC3UIntNormalizedSrgb = 78
        BC4Typeless = 79
        BC4UIntNormalized = 80
        BC4IntNormalized = 81
        BC5Typeless = 82
        BC5UIntNormalized = 83
        BC5IntNormalized = 84
        B5G6R5UIntNormalized = 85
        B5G5R5A1UIntNormalized = 86
        B8G8R8A8UIntNormalized = 87
        B8G8R8X8UIntNormalized = 88
        R10G10B10XRBiasA2UIntNormalized = 89
        B8G8R8A8Typeless = 90
        B8G8R8A8UIntNormalizedSrgb = 91
        B8G8R8X8Typeless = 92
        B8G8R8X8UIntNormalizedSrgb = 93
        BC6HTypeless = 94
        BC6H16UnsignedFloat = 95
        BC6H16Float = 96
        BC7Typeless = 97
        BC7UIntNormalized = 98
        BC7UIntNormalizedSrgb = 99
        Ayuv = 100
        Y410 = 101
        Y416 = 102
        NV12 = 103
        P010 = 104
        P016 = 105
        Opaque420 = 106
        Yuy2 = 107
        Y210 = 108
        Y216 = 109
        NV11 = 110
        AI44 = 111
        IA44 = 112
        P8 = 113
        A8P8 = 114
        B4G4R4A4UIntNormalized = 115
        P208 = 130
        V208 = 131
        V408 = 132
        SamplerFeedbackMinMipOpaque = 189
        SamplerFeedbackMipRegionUsedOpaque = 190
    End Enum

#End Region

#Region "Class"
    Sub New(Window As IWin32Window)
        Dim pIGraphicsCaptureSessionStatics As IntPtr = IntPtr.Zero
        If GetActivationFactory(WindowsGraphicsCaptureGraphicsCaptureSession,
                                IID_IGraphicsCaptureSessionStatics,
                                pIGraphicsCaptureSessionStatics) Then
            Dim IsSupported As Boolean = False
            If GraphicsCaptureSessionStatics_IsSupported(pIGraphicsCaptureSessionStatics,
                                                         IsSupported) Then
                If IsSupported Then
                    If GetActivateInstance(WindowsGraphicsCaptureGraphicsCapturePicker,
                                           IID_IGraphicsCapturePicker,
                                           m_pIGraphicsCapturePicker) Then
                        Dim pIInitializeWithWindow As IntPtr = IntPtr.Zero
                        If QueryInterface(m_pIGraphicsCapturePicker,
                                          IID_IInitializeWithWindow,
                                          pIInitializeWithWindow) Then
                            If InitializeWithWindow_Initialize(pIInitializeWithWindow,
                                                               Window.Handle) Then
                                m_IsInitialized = True
                            End If
                            Release(pIInitializeWithWindow)
                        End If
                    End If
                End If
            End If
            Release(pIGraphicsCaptureSessionStatics)
        End If
    End Sub
#End Region

#Region "Const"
    Private Const S_OK As Integer = 0
    Private Const GWL_STYLE As Integer = -16
    Private Const WS_MINIMIZE As Integer = &H20000000
    Private Const D3D11_SDK_VERSION As Integer = &H7

    Private Const WindowsGraphicsCaptureGraphicsCapturePicker As String = "Windows.Graphics.Capture.GraphicsCapturePicker"
    Private Const IID_IGraphicsCapturePicker As String = "5a1711b3-ad79-4b4a-9336-1318fdde3539"

    Private Const WindowsGraphicsCaptureGraphicsCaptureSession As String = "Windows.Graphics.Capture.GraphicsCaptureSession"
    Private Const IID_IGraphicsCaptureSessionStatics As String = "2224a540-5974-49aa-b232-0882536f4cb5"
    Private Const IID_IGraphicsCaptureSession As String = "814e42a9-f70f-4ad7-939b-fddcc6eb880d"
    Private Const IID_IGraphicsCaptureSession2 As String = "2c39ae40-7d2e-5044-804e-8b6799d4cf9e"

    Private Const WindowsGraphicsCaptureDirect3D11CaptureFramePool As String = "Windows.Graphics.Capture.Direct3D11CaptureFramePool"
    Private Const IID_IDirect3D11CaptureFramePool As String = "24eb6d22-1975-422e-82e7-780dbd8ddf24"
    Private Const IID_IDirect3D11CaptureFramePoolStatics As String = "7784056a-67aa-4d53-ae54-1088d5a8ca21"

    Private Const IID_IClosable As String = "30d5a829-7fa4-4026-83bb-d75bae4ea99e"
    Private Const IID_IAsyncInfo As String = "00000036-0000-0000-c000-000000000046"
    Private Const IID_IInitializeWithWindow As String = "3e68d4bd-7135-4d10-8018-9fb6d9f33fa1"

    Private Const IID_IDXGIDevice As String = "54ec77fa-1377-44e6-8c32-88fd5f44c84c"
    Private Const IID_IDirect3DDevice As String = "a37624ab-8d5f-4650-9d3e-9eae3d9bc670"
    Private Const IID_ID3D11Texture2D As String = "6f15aaf2-d208-4e89-9ab4-489535d34f9c"
    Private Const IID_IDirect3DDxgiInterfaceAccess As String = "a9b3d012-3df2-4ee3-b8d1-8695f457d3c1"
#End Region

#Region "Variablen"
    Private m_DisposedValue As Boolean = False
    Private ReadOnly m_IsInitialized As Boolean = False
    Private m_pIGraphicsCapturePicker As IntPtr = IntPtr.Zero
    Private m_CaptureName As String = String.Empty
    Private m_CaptureSize As New Size
    Private m_IsCursorCaptureEnabled As Boolean = True
#End Region

#Region "Structure"
    Private Structure DXGI_SAMPLE_DESC
        Dim Count As Integer
        Dim Quality As Integer
    End Structure

    Private Structure D3D11_TEXTURE2D_DESC
        Dim Width As Integer
        Dim Height As Integer
        Dim MipLevels As Integer
        Dim ArraySize As Integer
        Dim Format As Integer
        Dim SampleDesc As DXGI_SAMPLE_DESC
        Dim Usage As D3D11_USAGE
        Dim BindFlags As D3D11_BIND_FLAG
        Dim CPUAccessFlags As D3D11_CPU_ACCESS_FLAG
        Dim MiscFlags As D3D11_RESOURCE_MISC_FLAG
    End Structure

    Private Structure D3D11_MAPPED_SUBRESOURCE
        Dim pData As IntPtr
        Dim RowPitch As Integer
        Dim DepthPitch As Integer
    End Structure
#End Region

#Region "Properties"
    Public ReadOnly Property IsInitialized As Boolean
        Get
            Return m_IsInitialized
        End Get
    End Property

    Public ReadOnly Property CaptureName As String
        Get
            Return m_CaptureName
        End Get
    End Property

    Public ReadOnly Property CaptureSize As Size
        Get
            Return m_CaptureSize
        End Get
    End Property

    Public Property IncludeCursor As Boolean
        Set(value As Boolean)
            m_IsCursorCaptureEnabled = value
        End Set
        Get
            Return m_IsCursorCaptureEnabled
        End Get
    End Property
#End Region

#Region "Public Functions"
    Public Function PickSingleItem() As Bitmap
        Dim Ret As Boolean = False
        Dim BmpRet As Bitmap = Nothing
        If Me.IsInitialized Then
            Dim pIGraphicsCaptureItem As IntPtr = IntPtr.Zero
            If GraphicsCapturePicker_PickSingleItemAsync(m_pIGraphicsCapturePicker,
                                                         pIGraphicsCaptureItem) Then
                If WaitForAsync(pIGraphicsCaptureItem) Then
                    If pIGraphicsCaptureItem <> IntPtr.Zero Then
                        Dim hString As IntPtr = IntPtr.Zero
                        If GraphicsCaptureItem_GetDisplayName(pIGraphicsCaptureItem, hString) Then
                            m_CaptureName = Marshal.PtrToStringUni(WindowsGetStringRawBuffer(hString, 0))
                            If GraphicsCaptureItem_GetSize(pIGraphicsCaptureItem, m_CaptureSize) Then
                                If m_CaptureSize.Width <> 0 AndAlso m_CaptureSize.Height <> 0 Then
                                    Ret = True
                                    Dim hCaptureWnd As IntPtr = FindWindow(IntPtr.Zero, WindowsGetStringRawBuffer(hString, 0))
                                    If hCaptureWnd <> IntPtr.Zero Then
                                        If CBool(GetWindowLong(hCaptureWnd, GWL_STYLE) And WS_MINIMIZE) Then
                                            Ret = False
                                            MessageBox.Show("Von dem Fenster '" & m_CaptureName & "' kann kein Screenshot erstellt werden da es minimiert ist.", "CapturePicker")
                                        End If
                                    End If
                                Else
                                    MessageBox.Show("Von dem Fenster '" & m_CaptureName & "' kann kein Screenshot erstellt werden.", "CapturePicker")
                                End If
                            End If
                        End If
                        If Ret Then
                            BmpRet = StartCapture(pIGraphicsCaptureItem)
                        End If
                    Else
                        'MessageBox.Show("Abbrechen ausgewählt.", "CapturePicker")
                    End If
                End If
            End If
            Release(pIGraphicsCaptureItem)
        End If
        Return BmpRet
    End Function
#End Region

#Region "Private Functions"
    Private Function StartCapture(pIGraphicsCaptureItem As IntPtr) As Bitmap
        Dim Ret As Bitmap = Nothing
        Dim pIDirect3D11CaptureFramePoolStatics As IntPtr = IntPtr.Zero
        If GetActivationFactory(WindowsGraphicsCaptureDirect3D11CaptureFramePool,
                                IID_IDirect3D11CaptureFramePoolStatics,
                                pIDirect3D11CaptureFramePoolStatics) Then
            Dim CaptureSize As New Size
            If GraphicsCaptureItem_GetSize(pIGraphicsCaptureItem, CaptureSize) Then
                Dim pID3D11Device As IntPtr = IntPtr.Zero
                Dim pID3D11DeviceContext As IntPtr = IntPtr.Zero
                If D3D11CreateDevice(IntPtr.Zero, D3D_DRIVER_TYPE.D3D_DRIVER_TYPE_HARDWARE,
                                     IntPtr.Zero, D3D11_CREATE_DEVICE_FLAG.D3D11_CREATE_DEVICE_BGRA_SUPPORT,
                                     0, 0, D3D11_SDK_VERSION, pID3D11Device, 0, pID3D11DeviceContext) = S_OK Then
                    Dim pIDXGIDevice As IntPtr = IntPtr.Zero
                    If QueryInterface(pID3D11Device,
                                      IID_IDXGIDevice,
                                      pIDXGIDevice) Then
                        Dim pIInspectable As IntPtr
                        If CreateDirect3D11DeviceFromDXGIDevice(pIDXGIDevice,
                                                                pIInspectable) = S_OK Then
                            Dim pIDirect3DDevice As IntPtr = IntPtr.Zero
                            If QueryInterface(pIInspectable,
                                              IID_IDirect3DDevice,
                                              pIDirect3DDevice) Then
                                Dim pIDirect3D11CaptureFramePool As IntPtr = IntPtr.Zero
                                If Direct3D11CaptureFramePoolStatics_Create(pIDirect3D11CaptureFramePoolStatics,
                                                                            pIDirect3DDevice,
                                                                            DirectXPixelFormat.B8G8R8A8UIntNormalized, 1,
                                                                            CaptureSize,
                                                                            pIDirect3D11CaptureFramePool) Then
                                    Dim pIGraphicsCaptureSession As IntPtr = IntPtr.Zero
                                    If Direct3D11CaptureFramePool_CreateCaptureSession(pIDirect3D11CaptureFramePool,
                                                                                       pIGraphicsCaptureItem,
                                                                                       pIGraphicsCaptureSession) Then

                                        ' *********************************************************************************************************************
                                        ' Optional: Gets or sets a value specifying whether the capture session will include the cursor in the captured content.
                                        Dim pIGraphicsCaptureSession2 As IntPtr = IntPtr.Zero
                                        If QueryInterface(pIGraphicsCaptureSession,
                                                          IID_IGraphicsCaptureSession2,
                                                          pIGraphicsCaptureSession2) Then
                                            'Dim IsCursorCaptureEnabled As Boolean = False
                                            'If GraphicsCaptureSession2_GetIsCursorCaptureEnabled(pIGraphicsCaptureSession2,
                                            '                                                     IsCursorCaptureEnabled) Then
                                            '    Debug.Print("GetIsCursorCaptureEnabled = " & IsCursorCaptureEnabled.ToString)
                                            'End If

                                            If GraphicsCaptureSession2_PutIsCursorCaptureEnabled(pIGraphicsCaptureSession2,
                                                                                                 m_IsCursorCaptureEnabled) Then
                                                'Debug.Print("PutIsCursorCaptureEnabled successful")
                                            End If
                                            Release(pIGraphicsCaptureSession2)
                                        End If
                                        ' *********************************************************************************************************************

                                        If GraphicsCaptureSession_StartCapture(pIGraphicsCaptureSession) Then
                                            Dim pIDirect3D11CaptureFrame As IntPtr = IntPtr.Zero
                                            Do
                                                If Direct3D11CaptureFramePool_TryGetNextFrame(pIDirect3D11CaptureFramePool,
                                                                                              pIDirect3D11CaptureFrame) Then Application.DoEvents()
                                            Loop While pIDirect3D11CaptureFrame = IntPtr.Zero
                                            If pIDirect3D11CaptureFrame <> IntPtr.Zero Then
                                                Dim pIDirect3DSurface As IntPtr = IntPtr.Zero
                                                If Direct3D11CaptureFrame_GetSurface(pIDirect3D11CaptureFrame,
                                                                                     pIDirect3DSurface) Then
                                                    Ret = GetImageFromIDirect3DSurface(pIDirect3DSurface,
                                                                                       pID3D11Device,
                                                                                       pID3D11DeviceContext)
                                                    CloseAndRelease(pIDirect3DSurface)
                                                End If
                                                CloseAndRelease(pIDirect3D11CaptureFrame)
                                            End If
                                        End If
                                        CloseAndRelease(pIGraphicsCaptureSession)
                                    End If
                                    CloseAndRelease(pIDirect3D11CaptureFramePool)
                                End If
                                CloseAndRelease(pIDirect3DDevice)
                            End If
                            CloseAndRelease(pIInspectable)
                        End If
                        Release(pIDXGIDevice)
                    End If
                    Release(pID3D11Device)
                    Release(pID3D11DeviceContext)
                End If
            End If
            Release(pIDirect3D11CaptureFramePoolStatics)
        End If
        Return Ret
    End Function

    Private Function GetImageFromIDirect3DSurface(pIDirect3DSurface As IntPtr,
                                                  pID3D11Device As IntPtr,
                                                  pID3D11DeviceContext As IntPtr) As Bitmap
        Dim Ret As Bitmap = Nothing
        Dim pIDirect3DDxgiInterfaceAccess As IntPtr = IntPtr.Zero
        If QueryInterface(pIDirect3DSurface,
                          IID_IDirect3DDxgiInterfaceAccess,
                          pIDirect3DDxgiInterfaceAccess) Then
            Dim pID3D11Texture2D As IntPtr = IntPtr.Zero
            If Direct3DDxgiInterfaceAccess_GetInterface(pIDirect3DDxgiInterfaceAccess,
                                                        New Guid(IID_ID3D11Texture2D),
                                                        pID3D11Texture2D) Then
                Dim tD3D11_TEXTURE2D_DESC As D3D11_TEXTURE2D_DESC
                D3D11Texture2D_GetDesc(pID3D11Texture2D, tD3D11_TEXTURE2D_DESC)
                With tD3D11_TEXTURE2D_DESC
                    .Usage = D3D11_USAGE.D3D11_USAGE_STAGING
                    .BindFlags = D3D11_BIND_FLAG.D3D11_BIND_DEFAULT
                    .MiscFlags = D3D11_RESOURCE_MISC_FLAG.D3D11_RESOURCE_MISC_DEFAULT
                    .CPUAccessFlags = D3D11_CPU_ACCESS_FLAG.D3D11_CPU_ACCESS_READ
                End With
                Dim pID3D11Texture2D_2 As IntPtr = IntPtr.Zero
                If D3D11Device_CreateTexture2D(pID3D11Device,
                                               tD3D11_TEXTURE2D_DESC,
                                               IntPtr.Zero,
                                               pID3D11Texture2D_2) Then
                    If D3D11DeviceContext_CopyResource(pID3D11DeviceContext,
                                                       pID3D11Texture2D_2,
                                                       pID3D11Texture2D) Then
                        Dim tD3D11_MAPPED_SUBRESOURCE As New D3D11_MAPPED_SUBRESOURCE
                        If D3D11DeviceContext_Map(pID3D11DeviceContext,
                                                  pID3D11Texture2D_2, 0,
                                                  D3D11_MAP.D3D11_MAP_READ,
                                                  0, tD3D11_MAPPED_SUBRESOURCE) Then

                            Ret = New Bitmap(tD3D11_TEXTURE2D_DESC.Width,
                                             tD3D11_TEXTURE2D_DESC.Height,
                                             tD3D11_MAPPED_SUBRESOURCE.RowPitch,
                                             Imaging.PixelFormat.Format32bppArgb,
                                             tD3D11_MAPPED_SUBRESOURCE.pData)

                        End If
                    End If
                    Release(pID3D11Texture2D_2)
                End If
                Release(pID3D11Texture2D)
            End If
            Release(pIDirect3DDxgiInterfaceAccess)
        End If
        Return Ret
    End Function

    Private Function GetActivationFactory(ClassName As String,
                                          IID As String,
                                          ByRef pFactory As IntPtr) As Boolean
        Dim Ret As Boolean = False
        Dim hString As IntPtr = IntPtr.Zero
        If WindowsCreateString(ClassName, ClassName.Length, hString) = S_OK Then
            If hString <> IntPtr.Zero Then
                If RoGetActivationFactory(hString, New Guid(IID), pFactory) = S_OK Then Ret = True
                WindowsDeleteString(hString)
            End If
        End If
        Return Ret
    End Function

    Private Function GetActivateInstance(ClassName As String,
                                         IID As String,
                                         ByRef pInstance As IntPtr) As Boolean
        Dim Ret As Boolean = False
        Dim hString As IntPtr = IntPtr.Zero
        If WindowsCreateString(ClassName, ClassName.Length, hString) = S_OK Then
            If hString <> IntPtr.Zero Then
                Dim pIInspectable As IntPtr = IntPtr.Zero
                If RoActivateInstance(hString, pIInspectable) = S_OK Then
                    If pIInspectable <> IntPtr.Zero Then
                        If QueryInterface(pIInspectable, IID, pInstance) Then
                            If pInstance <> IntPtr.Zero Then Ret = True
                        End If
                        Release(pIInspectable)
                    End If
                End If
                WindowsDeleteString(hString)
            End If
        End If
        Return Ret
    End Function

    Private Function WaitForAsync(ByRef pInterface As IntPtr) As Boolean
        Dim Ret As Boolean = False
        If pInterface <> IntPtr.Zero Then
            Dim pIAsyncInfo As IntPtr = IntPtr.Zero
            If QueryInterface(pInterface, IID_IAsyncInfo, pIAsyncInfo) Then
                Dim eStatus As AsyncStatus
                Do
                    If AsyncInfo_GetStatus(pIAsyncInfo, eStatus) Then Application.DoEvents()
                Loop While eStatus = AsyncStatus.Started
                If eStatus = AsyncStatus.Completed Then
                    Ret = True
                Else
                    AsyncInfo_Close(pIAsyncInfo)
                End If
                Release(pIAsyncInfo)
                If Ret Then
                    Dim pRet As IntPtr = IntPtr.Zero
                    If AsyncInterface_GetResults(pInterface, pRet) Then
                        Release(pInterface)
                        pInterface = pRet
                    End If
                End If
            End If
        End If
        Return Ret
    End Function

    Private Function GetVTablePtr(pInterface As IntPtr,
                                  intMethodNumber As VTable_Interfaces,
                                  ByRef pVTablePtr As IntPtr) As Boolean
        Dim Ret As Boolean = False
        If pInterface <> IntPtr.Zero AndAlso intMethodNumber >= 0 Then
            Dim pVTablePtrs As IntPtr() = New IntPtr(0) {}
            Marshal.Copy(IntPtr.Add(Marshal.ReadIntPtr(pInterface),
                                    IntPtr.Size * intMethodNumber),
                                    pVTablePtrs, 0, 1)
            pVTablePtr = pVTablePtrs(0)
            Ret = True
        End If
        Return Ret
    End Function

    Private Sub Release(ByRef pInterface As IntPtr)
        If pInterface <> IntPtr.Zero Then
            Marshal.Release(pInterface)
            pInterface = IntPtr.Zero
        End If
    End Sub

    Private Sub CloseAndRelease(ByRef pInterface As IntPtr)
        If pInterface <> IntPtr.Zero Then
            Dim pIClosable As IntPtr = IntPtr.Zero
            If QueryInterface(pInterface, IID_IClosable, pIClosable) Then
                If Closable_Close(pIClosable) Then
                    Marshal.Release(pIClosable)
                    Marshal.Release(pInterface)
                    pInterface = IntPtr.Zero
                End If
            End If
        End If
    End Sub

    Private Function QueryInterface(pInterface As IntPtr,
                                IID As String,
                                ByRef pIOut As IntPtr) As Boolean
        Dim Ret As Boolean = False
        If pInterface <> IntPtr.Zero Then
            If Marshal.QueryInterface(pInterface, New Guid(IID), pIOut) = S_OK Then Ret = True
        End If
        Return Ret
    End Function
#End Region

#Region "Interface Delegates"
    Private Delegate Function IClosable_Close(<[In]> this As IntPtr) As Integer

    Private Delegate Function IAsyncInfo_GetStatus(<[In]> this As IntPtr,
                                                    <Out> ByRef status As AsyncStatus) As Integer

    Private Delegate Function IAsyncInfo_Close(<[In]> this As IntPtr) As Integer

    Private Delegate Function IAsyncInterface_GetResults(<[In]> this As IntPtr,
                                                         <Out> ByRef results As IntPtr) As Integer

    Private Delegate Function IGraphicsCaptureSessionStatics_IsSupported(<[In]> this As IntPtr,
                                                                         <Out, MarshalAs(UnmanagedType.Bool)> ByRef result As Boolean) As Integer

    Private Delegate Function IInitializeWithWindow_Initialize(<[In]> this As IntPtr,
                                                               <[In]> hwnd As IntPtr) As Integer

    Private Delegate Function IGraphicsCapturePicker_PickSingleItemAsync(<[In]> this As IntPtr,
                                                                         <Out> ByRef operation As IntPtr) As Integer

    Private Delegate Function IGraphicsCaptureItem_GetDisplayName(<[In]> this As IntPtr,
                                                                  <Out> ByRef value As IntPtr) As Integer

    Private Delegate Function IGraphicsCaptureItem_GetSize(<[In]> this As IntPtr,
                                                           <Out> ByRef value As Size) As Integer

    Private Delegate Function IDirect3D11CaptureFramePoolStatics_Create(<[In]> this As IntPtr,
                                                                        <[In]> device As IntPtr,
                                                                        <[In]> pixelFormat As DirectXPixelFormat,
                                                                        <[In]> numberOfBuffers As Integer,
                                                                        <[In]> size As Size,
                                                                        <Out> ByRef result As IntPtr) As Integer

    Private Delegate Function IDirect3D11CaptureFramePool_CreateCaptureSession(<[In]> this As IntPtr,
                                                                               <[In]> item As IntPtr,
                                                                               <Out> ByRef result As IntPtr) As Integer

    Private Delegate Function IGraphicsCaptureSession_StartCapture(<[In]> this As IntPtr) As Integer

    Private Delegate Function IGraphicsCaptureSession2_GetIsCursorCaptureEnabled(<[In]> this As IntPtr,
                                                                                 <Out, MarshalAs(UnmanagedType.Bool)> ByRef value As Boolean) As Integer

    Private Delegate Function IGraphicsCaptureSession2_PutIsCursorCaptureEnabled(<[In]> this As IntPtr,
                                                                                 <[In], MarshalAs(UnmanagedType.Bool)> value As Boolean) As Integer

    Private Delegate Function IDirect3D11CaptureFramePool_TryGetNextFrame(<[In]> this As IntPtr,
                                                                          <Out> ByRef result As IntPtr) As Integer

    Private Delegate Function IDirect3D11CaptureFrame_GetSurface(<[In]> this As IntPtr,
                                                                 <Out> ByRef value As IntPtr) As Integer

    Private Delegate Function IDirect3DDxgiInterfaceAccess_GetInterface(<[In]> this As IntPtr,
                                                                        <[In], MarshalAs(UnmanagedType.LPStruct)> iid As Guid,
                                                                        <Out> ByRef p As IntPtr) As Integer

    Private Delegate Sub ID3D11Texture2D_GetDesc(<[In]> this As IntPtr,
                                                 <Out> ByRef pDesc As D3D11_TEXTURE2D_DESC)

    Private Delegate Function ID3D11Device_CreateTexture2D(<[In]> this As IntPtr,
                                                           <[In]> ByRef pDesc As D3D11_TEXTURE2D_DESC,
                                                           <[In]> pInitialData As IntPtr,
                                                           <Out> ByRef ppTexture2D As IntPtr) As Integer

    Private Delegate Function ID3D11DeviceContext_CopyResource(<[In]> this As IntPtr,
                                                               <[In]> pDstResource As IntPtr,
                                                               <[In]> pSrcResource As IntPtr) As Integer

    Private Delegate Function ID3D11DeviceContext_Map(<[In]> this As IntPtr,
                                                      <[In]> pResource As IntPtr,
                                                      <[In]> Subresource As Integer,
                                                      <[In]> MapType As D3D11_MAP,
                                                      <[In]> MapFlags As Integer,
                                                      <Out> ByRef pMappedResource As D3D11_MAPPED_SUBRESOURCE) As Integer

#End Region

#Region "Interface Functions"
    Private Function Closable_Close(this As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim Ret As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IClosable_Close, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IClosable_Close)),
                                                           IClosable_Close).Invoke(this) = S_OK Then Ret = True
        End If
        Return Ret
    End Function

    Private Function AsyncInfo_GetStatus(this As IntPtr,
                                         ByRef status As AsyncStatus) As Boolean
        Dim pVTablePtr As IntPtr
        Dim Ret As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IAsyncInfo_GetStatus, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IAsyncInfo_GetStatus)),
                                                           IAsyncInfo_GetStatus).Invoke(this, status) = S_OK Then Ret = True
        End If
        Return Ret
    End Function

    Private Function AsyncInfo_Close(this As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim Ret As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IAsyncInfo_Close, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IAsyncInfo_Close)),
                                                           IAsyncInfo_Close).Invoke(this) = S_OK Then Ret = True
        End If
        Return Ret
    End Function

    Private Function AsyncInterface_GetResults(this As IntPtr,
                                               ByRef results As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim Ret As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IAsyncInterface_GetResults, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IAsyncInterface_GetResults)),
                                                           IAsyncInterface_GetResults).Invoke(this, results) = S_OK Then Ret = True
        End If
        Return Ret
    End Function

    Private Function GraphicsCaptureSessionStatics_IsSupported(this As IntPtr,
                                                               ByRef result As Boolean) As Boolean
        Dim pVTablePtr As IntPtr
        Dim Ret As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IGraphicsCaptureSessionStatics_IsSupported, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IGraphicsCaptureSessionStatics_IsSupported)),
                                                           IGraphicsCaptureSessionStatics_IsSupported).Invoke(this, result) = S_OK Then Ret = True
        End If
        Return Ret
    End Function

    Private Function InitializeWithWindow_Initialize(this As IntPtr,
                                                     hwnd As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim Ret As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IInitializeWithWindow_Initialize, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IInitializeWithWindow_Initialize)),
                                                           IInitializeWithWindow_Initialize).Invoke(this, hwnd) = S_OK Then Ret = True
        End If
        Return Ret
    End Function

    Private Function GraphicsCapturePicker_PickSingleItemAsync(this As IntPtr,
                                                               ByRef operation As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim Ret As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IGraphicsCapturePicker_PickSingleItemAsync, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IGraphicsCapturePicker_PickSingleItemAsync)),
                                                           IGraphicsCapturePicker_PickSingleItemAsync).Invoke(this, operation) = S_OK Then Ret = True
        End If
        Return Ret
    End Function

    Private Function GraphicsCaptureItem_GetDisplayName(this As IntPtr,
                                                        ByRef value As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim Ret As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IGraphicsCaptureItem_GetDisplayName, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IGraphicsCaptureItem_GetDisplayName)),
                                                           IGraphicsCaptureItem_GetDisplayName).Invoke(this, value) = S_OK Then Ret = True
        End If
        Return Ret
    End Function

    Private Function GraphicsCaptureItem_GetSize(this As IntPtr,
                                                 ByRef value As Size) As Boolean
        Dim pVTablePtr As IntPtr
        Dim Ret As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IGraphicsCaptureItem_GetSize, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IGraphicsCaptureItem_GetSize)),
                                                           IGraphicsCaptureItem_GetSize).Invoke(this, value) = S_OK Then Ret = True
        End If
        Return Ret
    End Function

    Private Function Direct3D11CaptureFramePoolStatics_Create(this As IntPtr,
                                                              device As IntPtr,
                                                              pixelFormat As DirectXPixelFormat,
                                                              numberOfBuffers As Integer,
                                                              size As Size,
                                                              ByRef result As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim Ret As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IDirect3D11CaptureFramePoolStatics_Create, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IDirect3D11CaptureFramePoolStatics_Create)),
                                                           IDirect3D11CaptureFramePoolStatics_Create).Invoke(this, device, pixelFormat, numberOfBuffers, size, result) = S_OK Then Ret = True
        End If
        Return Ret
    End Function

    Private Function Direct3D11CaptureFramePool_CreateCaptureSession(this As IntPtr,
                                                                     item As IntPtr,
                                                                     ByRef result As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim Ret As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IDirect3D11CaptureFramePool_CreateCaptureSession, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IDirect3D11CaptureFramePool_CreateCaptureSession)),
                                                           IDirect3D11CaptureFramePool_CreateCaptureSession).Invoke(this, item, result) = S_OK Then Ret = True
        End If
        Return Ret
    End Function

    Private Function GraphicsCaptureSession_StartCapture(this As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim Ret As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IGraphicsCaptureSession_StartCapture, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IGraphicsCaptureSession_StartCapture)),
                                                           IGraphicsCaptureSession_StartCapture).Invoke(this) = S_OK Then Ret = True
        End If
        Return Ret
    End Function

    Private Function GraphicsCaptureSession2_GetIsCursorCaptureEnabled(this As IntPtr,
                                                                       ByRef value As Boolean) As Boolean
        Dim pVTablePtr As IntPtr
        Dim Ret As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IGraphicsCaptureSession2_GetIsCursorCaptureEnabled, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IGraphicsCaptureSession2_GetIsCursorCaptureEnabled)),
                                                           IGraphicsCaptureSession2_GetIsCursorCaptureEnabled).Invoke(this, value) = S_OK Then Ret = True
        End If
        Return Ret
    End Function

    Private Function GraphicsCaptureSession2_PutIsCursorCaptureEnabled(this As IntPtr,
                                                                       value As Boolean) As Boolean
        Dim pVTablePtr As IntPtr
        Dim Ret As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IGraphicsCaptureSession2_PutIsCursorCaptureEnabled, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IGraphicsCaptureSession2_PutIsCursorCaptureEnabled)),
                                                           IGraphicsCaptureSession2_PutIsCursorCaptureEnabled).Invoke(this, value) = S_OK Then Ret = True
        End If
        Return Ret
    End Function

    Private Function Direct3D11CaptureFramePool_TryGetNextFrame(this As IntPtr,
                                                                ByRef result As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim Ret As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IDirect3D11CaptureFramePool_TryGetNextFrame, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IDirect3D11CaptureFramePool_TryGetNextFrame)),
                                                           IDirect3D11CaptureFramePool_TryGetNextFrame).Invoke(this, result) = S_OK Then Ret = True
        End If
        Return Ret
    End Function

    Private Function Direct3D11CaptureFrame_GetSurface(this As IntPtr,
                                                       ByRef value As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim Ret As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IDirect3D11CaptureFrame_GetSurface, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IDirect3D11CaptureFrame_GetSurface)),
                                                           IDirect3D11CaptureFrame_GetSurface).Invoke(this, value) = S_OK Then Ret = True
        End If
        Return Ret
    End Function

    Private Function Direct3DDxgiInterfaceAccess_GetInterface(this As IntPtr,
                                                              iid As Guid,
                                                              ByRef p As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim Ret As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.IDirect3DDxgiInterfaceAccess_GetInterface, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(IDirect3DDxgiInterfaceAccess_GetInterface)),
                                                           IDirect3DDxgiInterfaceAccess_GetInterface).Invoke(this, iid, p) = S_OK Then Ret = True
        End If
        Return Ret
    End Function

    Private Sub D3D11Texture2D_GetDesc(this As IntPtr,
                                       ByRef pDesc As D3D11_TEXTURE2D_DESC)
        Dim pVTablePtr As IntPtr
        Dim Ret As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.ID3D11Texture2D_GetDesc, pVTablePtr) Then
            CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(ID3D11Texture2D_GetDesc)),
                                                        ID3D11Texture2D_GetDesc).Invoke(this, pDesc)
        End If
    End Sub

    Private Function D3D11Device_CreateTexture2D(this As IntPtr,
                                                 pDesc As D3D11_TEXTURE2D_DESC,
                                                 pInitialData As IntPtr,
                                                 ByRef ppTexture2D As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim Ret As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.ID3D11Device_CreateTexture2D, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(ID3D11Device_CreateTexture2D)),
                                                           ID3D11Device_CreateTexture2D).Invoke(this, pDesc, pInitialData, ppTexture2D) = S_OK Then Ret = True
        End If
        Return Ret
    End Function

    Private Function D3D11DeviceContext_CopyResource(this As IntPtr,
                                                     pDstResource As IntPtr,
                                                     pSrcResource As IntPtr) As Boolean
        Dim pVTablePtr As IntPtr
        Dim Ret As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.ID3D11DeviceContext_CopyResource, pVTablePtr) Then
            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(ID3D11DeviceContext_CopyResource)),
                                                           ID3D11DeviceContext_CopyResource).Invoke(this, pDstResource, pSrcResource) = S_OK Then Ret = True
        End If
        Return Ret
    End Function

    Private Function D3D11DeviceContext_Map(this As IntPtr,
                                            pResource As IntPtr,
                                            Subresource As Integer,
                                            MapType As D3D11_MAP,
                                            MapFlags As Integer,
                                            ByRef pMappedResource As D3D11_MAPPED_SUBRESOURCE) As Boolean
        Dim pVTablePtr As IntPtr
        Dim Ret As Boolean = False
        If this <> IntPtr.Zero AndAlso GetVTablePtr(this, VTable_Interfaces.ID3D11DeviceContext_Map, pVTablePtr) Then

            If CType(Marshal.GetDelegateForFunctionPointer(pVTablePtr, GetType(ID3D11DeviceContext_Map)),
                                                           ID3D11DeviceContext_Map).Invoke(this, pResource, Subresource, MapType, MapFlags, pMappedResource) = S_OK Then Ret = True
        End If
        Return Ret
    End Function
#End Region

#Region "Implements IDisposable"
    Protected Overridable Sub Dispose(disposing As Boolean)
        If Not m_DisposedValue Then
            If disposing Then
            End If
            Release(m_pIGraphicsCapturePicker)
            m_DisposedValue = True
        End If
    End Sub

    Public Sub Dispose() Implements IDisposable.Dispose
        Dispose(disposing:=True)
        GC.SuppressFinalize(Me)
    End Sub
#End Region

End Class
